// adapted from @urbanoxygen_ on instagram

float t = 0;
float diameter = 1000;

int levels = 3;

void setup() {
  size(1080, 1080);
}

void draw() {
  background(118,233,255);

  t = frameCount/1500.0;

  translate(width/2, height/2);
  rotate(PI*t*4);
  
  yinYang(diameter, levels);

}

void yinYang(float diameter, int n) {
  noStroke();
  fill(0);
  arc(0, 0, diameter, diameter, 0, PI);
  fill(255);
  arc(0, 0, diameter, diameter, PI, 2*PI);
  
  if(n==1) {
    fill(0);
    ellipse(-diameter/4, 0, diameter/2, diameter/2);
    fill(255);
    ellipse(diameter/4, 0, diameter/2, diameter/2);
    
    ellipse(-diameter/4, 0, diameter/4, diameter/4);
    
    fill(0);
    ellipse(diameter/4, 0, diameter/4, diameter/4);
  } else {
    push();
    translate(diameter/4, 0);
    rotate(PI*t*4);
    yinYang(diameter/2, n-1);
    pop();
    
    push();
    translate(-diameter/4, 0);
    rotate(PI*t*4);
    yinYang(diameter/2, n-1);
    pop();
  }
}
